/**
 * An application for demonstrating how to write a custom app for class testing.
 */
package tests;

import stringAnalyzer.Analyzer;
import static org.junit.Assert.*;
import org.junit.*;
import org.junit.rules.ExpectedException;



/**
 * @author hornick
 * This is a custom "test" class that tests the Analyzer class
 */
public class AnalyzerTester {

	/**
	 * @param args - not used
	 */
	public static void main(String[] args) throws Exception {
		Analyzer a = new Analyzer("a b c d e");		
		
		a.analyze();
		int nConsonants = a.getConsonantCount();
		int nVowels = a.getVowelCount();
		int nSpaces = a.getSpaceCount();
		
		System.out.println("Number of consonants= " + nConsonants );
		System.out.println("Number of vowels= " + nVowels );
		System.out.println("Number of blank spaces= " + nSpaces );
		
//		AnalyzerTester tester = new AnalyzerTester();
//		tester.test_abcde();
//		tester.test_HelloSE2030();
//		tester.test_NullPointerException();
//		tester.test_IllegalStateException();
	}	
	
	
	
	
	
	

	//Test case 1 
	public void test_abcde() {
		System.out.println("Test #1: a b c d e");

		Analyzer a = new Analyzer("a b c d e");		
		
		a.analyze();
		int nConsonants = a.getConsonantCount();
		int nVowels = a.getVowelCount();
		int nSpaces = a.getSpaceCount();
		
		System.out.println("Number of consonants=3: " + (nConsonants==3) );
		System.out.println("Number of vowels=2: " + (nVowels==2) );
		System.out.println("Number of blank spaces=4 " + (nSpaces==4) );
	}


	//Test case 2
	public void test_HelloSE2030() {
		System.out.println("\nTest #2: HELLO   SE2030" );
		Analyzer b = new Analyzer("HELLO	SE2030");
		b.analyze();
		
		int nConsonants = b.getConsonantCount();
		int nVowels = b.getVowelCount();
		int nSpaces = b.getSpaceCount();
		
		System.out.println("Number of consonants=4: " +  (nConsonants==4) );
		System.out.println("Number of vowels=3: "  +  (nVowels==3) );
		System.out.println("Number of blank spaces=1: "  + (nSpaces==1) );
	}

	//Test case 3
	public void test_NullPointerException() {
		System.out.println("\nTest #3: NullPointerException verification" );
		String temp = null;
		try {
			//NOTE: should throw NullPointerException since temp==null
			Analyzer c = new Analyzer(temp);
			System.out.println("Fail! Did not throw expected NullPointerException" );
		} catch( Exception e ) {
			if( e instanceof java.lang.NullPointerException ){				
				if( e.getMessage() != null && e.getMessage().equals("null string passed to Analyzer constructor")) {
					System.out.print("Success. Threw expected NullPointerException");
				
				} else {
					System.out.println("Fail! Did not throw expected NullPointerException!");
				}
			} else {
				System.out.println("Fail! Did not throw expected NullPointerException" );
			}
		}

	}
	
	//Test case 4
	public void test_IllegalStateException() {
		System.out.println("\nTest #4: IllegalStateException verification" );
		Analyzer c = new Analyzer("some string for testing purposes");
		// NOTE: should throw IllegalStateException since analyze is not called
		int count = c.getVowelCount();
		
		//TODO: complete this method
	}

	
}